unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ShapeControl(Several : array of TButton);
    procedure ButtonsClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.FormCreate(Sender: TObject);
begin
 borderstyle := bsnone;
end;

procedure TForm1.FormShow(Sender: TObject);
var Comp : TComponent;
    Buttons : array of TButton;
begin
 for Comp in Self do
 begin
  if Comp is TButton then
   begin
    setlength(Buttons,length({%H-}Buttons)+1);
    Buttons[pred(length(Buttons))] := Comp as TButton;
   end;//is TButton
 end;//comp

 ShapeControl(Buttons);
end;

procedure TForm1.ShapeControl(Several : array of TButton);
var
  ABitmap: TBitmap;
  lv : integer;
begin
  ABitmap := TBitmap.Create;
  ABitmap.Monochrome := True;
  ABitmap.Width := Width;
  ABitmap.Height := Height;

  with ABitmap.Canvas do
  begin
    Brush.Color := clBlack; // transparent color
    FillRect(0, 0,Width, Height);
    Brush.Color := clWhite; // mask color
    for lv := 0 to pred(length(Several)) do
    FillRect(Several[lv].Left,Several[lv].Top,Several[lv].Left+ Several[lv].Width,Several[lv].Top+ Several[lv].Height);
  end;
  SetShape(ABitmap);
  ABitmap.Free;
end;

procedure TForm1.ButtonsClick(Sender: TObject);
begin
  showmessage('TestShapeControl');
  close;
end;


end.

